#!/usr/bin/python2.5
# -*- coding: utf-8 -*-

#  PycaWM
#  test.py
#  Copyright (c) 2007 Vincent Rasneur, Anaël Verrier

#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; version 3 only.

#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import sys

if sys.version_info < (2, 5):
    raise ImportError('test module needs at least Python 2.5!')

import doctest
import os

def get_test_files():
    test_dir = 'tests'
    test_ext = '.test'
    for test_file in os.listdir(test_dir):
        if test_file.endswith(test_ext):
            yield os.path.join(test_dir, test_file)

def run_tests():
    failed = 0
    total = 0
    for test_file in get_test_files():
        print "** Running the test in %s" % (test_file,)
        (f, t) = doctest.testfile(test_file, module_relative=False,
                                  verbose=False, optionflags=doctest.ELLIPSIS)
        failed += f
        total += t
    return failed, total

if __name__ == '__main__':
    (failed, total) = run_tests()
    print "*** All tests are finished now!"
    print "%d tests have been running." % (total,)
    if failed:
        print "%d tests have failed! Go fix the bugs!" % (failed,)
    else:
        print "They all have succeeded, commit immediately !"
